;TIP1049A.LSP:  FUNCERR.LSP     Coding Tips     (C)1994, Richard Dipaola

;--------------------------------------------------------------------
; Example Function to start each routine.
(defun st_art (/ A)
   (setq RESET T 
      OLDERR *error* 
      *error* FUNCERR
      UN_DO (getvar "UNDOCTL")
   )
   (varset "cmdecho" 0)
   (cond
      ((= UN_DO 0)
         (command ".undo" "All")
      )
      ((= UN_DO 3)
         (command ".undo" "c" "All")
      )
   )
   (command ".undo" "g")
)
;--------------------------------------------------------------------
; Example Function to set variable and save original setting.
(defun varset (VAR VAL)
   (if (not (assoc VAR VARLIST))
      (setq VARLIST (cons (list VAR (getvar VAR)) VARLIST))
   )
   (setvar VAR VAL)
)
;--------------------------------------------------------------------
; Example Function to restore original drawing variable settings.
(defun ex_it ()
   (command ".undo" "e")
   (repeat (LENGTH VARLIST)
      (setvar (caar VARLIST) (cadar VARLIST))
      (setq VARLIST (cdr VARLIST))
   )
   (setq *error* OLDERR 
   RESET nil)
   (command nil nil)
   (princ)
)
;--------------------------------------------------------------------
; Example Function for Error Handler
(defun funcerr (MSG)
   (If (/= MSG "Function cancelled")
      (princ MSG)
   )
   (command nil nil)
   (command ".UNDO" "e")
   (If RESET
      (progn
         (princ "\nUndoing...")
         (command ".undo" 1)
      )
   )
   (ex_it)
); end funcerr.lsp
